@echo off
title Community Made Zuma Mod Batch File
:menu
cls
REM --------------------------
REM ---
REM --- Main Menu
REM ---
REM --------------------------
color 0e
echo Ŀ
echo                          COMMUNITY MADE ZUMA MOD                             
echo Ĵ
echo  batch file version 1.0  mod version 1.1a                                   
echo Ĵ
echo  This is a replacement to the launcher due to legal gray areas.              
echo  This system of batch files might be updated or replaced in the future.      
echo Ĵ
echo  Select 1 to open Zuma Deluxe.                                               
echo  Select 2 to change difficulty.                                              
echo  Select 3 to change specific assets. (currently only exits)                  
echo  Select 4 to open readme.                                                    
echo  Select 5 to open a list of links.                                           
echo  Select 6 to install thumbnails.                                             
echo 
CHOICE /C 123456 /N
IF %ERRORLEVEL% EQU 1 goto zuma
IF %ERRORLEVEL% EQU 2 goto levelfolderscan
IF %ERRORLEVEL% EQU 3 goto assetscan
IF %ERRORLEVEL% EQU 4 goto readme
IF %ERRORLEVEL% EQU 5 goto links
IF %ERRORLEVEL% EQU 6 goto thumbnailscan
REM --------------------------
REM ---
REM --- Links
REM ---
REM --------------------------
:links
cls
color 0b
echo Ŀ
echo  Links                                                                       
echo Ĵ
echo  1  Sphere Matchers forum                                                   
echo  2  Forum thread                                                            
echo  3  CMZM Discord                                                            
echo  4  CMZM Steam Group                                                        
echo  5  CMZM Steam Guide                                                        
echo Ĵ
echo  B  Go back                                                                 
echo 
CHOICE /C 12345B /N
IF %ERRORLEVEL% EQU 1 goto smatchers
IF %ERRORLEVEL% EQU 2 goto thread
IF %ERRORLEVEL% EQU 3 goto discord
IF %ERRORLEVEL% EQU 4 goto group
IF %ERRORLEVEL% EQU 5 goto guide
:smatchers
rundll32 url.dll,FileProtocolHandler "http://spherematchers.boards.net"
goto menu
:thread
rundll32 url.dll,FileProtocolHandler "http://spherematchers.boards.net/thread/12/zuma-deluxe-community-mod"
goto menu
:discord
rundll32 url.dll,FileProtocolHandler "https://discord.gg/2uMYbpZ"
goto menu
:group
rundll32 url.dll,FileProtocolHandler "https://steamcommunity.com/groups/communitymadezumamod"
goto menu
:guide
rundll32 url.dll,FileProtocolHandler "https://steamcommunity.com/sharedfiles/filedetails/?id=1929596236"
goto menu
REM --------------------------
REM ---
REM --- Readme
REM ---
REM --------------------------
:readme
IF EXIST "cmzm_readme.html" (
  cls
  cmzm_readme.html
  goto menu
) ELSE (
  cls
  color 0c
  echo Ŀ
  echo  cmzm_readme.html could not be found!                                        
  echo 
  echo Are you running this in the correct folder?
  echo If so, is it named properly?
  echo.
  echo Press any key to go back to the main menu.
  pause >nul
  goto menu
)
REM --------------------------
REM ---
REM --- Opening Zuma
REM ---
REM --------------------------
:zuma
IF EXIST "Zuma.exe" (
  cls
  color 07
  echo Ŀ
  echo  This command-line window can be now closed.                                 
  echo 
  Zuma.exe
  exit
) ELSE (
  cls
  color 0c
  echo Ŀ
  echo  Zuma.exe could not be found!                                                
  echo 
  echo Are you running this in the correct folder?
  echo If so, is it named properly?
  echo.
  echo Press any key to exit.
  pause >nul
  exit
)
REM --------------------------
REM ---
REM --- Difficulty Selector
REM ---
REM --------------------------
:levelfolderscan
cls --- Check if levels folder exists
color 0b
echo Ŀ
echo  Checking for levels folder...                                               
echo 
IF EXIST "levels" (
  goto xmlscan
) ELSE (
  color 0c
  cls
  echo Ŀ
  echo  Levels folder not found!                                                    
  echo 
  echo Are you running this in the correct folder?
  echo If so, is it named properly?
  echo.
  echo Press any key to go back to the main menu.
  pause >nul
  goto menu
)
:xmlscan
cls
REM --- Check for levels.xml
color 0b
echo Ŀ
echo  Checking if levels.xml exists...                                            
echo 
IF EXIST "levels\levels.xml" (
  goto diffiscan
) ELSE (
  goto diffi_noxml
)
:diffiscan
cls
set difficulty=x
REM --- Easy
find "CMZM_EASY" levels\levels.xml
IF %ERRORLEVEL% EQU 0 set difficulty=e && goto diffi
REM --- Normal
find "CMZM_NORM" levels\levels.xml
IF %ERRORLEVEL% EQU 0 set difficulty=n && goto diffi
REM --- Hard
find "CMZM_HARD" levels\levels.xml
IF %ERRORLEVEL% EQU 0 set difficulty=h && goto diffi
REM --- Lunatic
find "CMZM_LUNA" levels\levels.xml
IF %ERRORLEVEL% EQU 0 set difficulty=l && goto diffi
:diffi_noxml
color 0c
set difficulty=x
echo levels.xml was not found! You must select a difficulty.
echo Press any key to go to the Difficulty Selector.
pause >nul
goto diffi
:diffi
cls
color 0e
echo Ŀ
echo  Difficulty Selector                                                         
echo  Select the following letter to change your difficulty.                      
echo Ĵ
IF %difficulty% EQU e echo  Selected Difficulty: Easy                                                   
IF %difficulty% EQU n echo  Selected Difficulty: Normal                                                 
IF %difficulty% EQU h echo  Selected Difficulty: Hard                                                   
IF %difficulty% EQU l echo  Selected Difficulty: Lunatic                                                
IF %difficulty% EQU x echo  Selected Difficulty: Nothing                                                
echo Ĵ
echo  E  Easy                                                                    
echo  N  Normal                                                                  
echo  H  Hard                                                                    
echo  L  Lunatic                                                                 
echo Ĵ
echo  B  Go back                                                                 
echo 
CHOICE /C ENHLB /N
IF %ERRORLEVEL% EQU 1 goto eas
IF %ERRORLEVEL% EQU 2 goto nor
IF %ERRORLEVEL% EQU 3 goto har
IF %ERRORLEVEL% EQU 4 goto lun
IF %ERRORLEVEL% EQU 5 goto menu
REM --------------------------
REM ---
REM --- Change to difficulties and open Zuma
REM ---
REM --------------------------
:eas
cls
copy /y extras\assets\xmls\levels\lvls-e.xml levels\levels.xml >nul
goto zuma
:nor
cls
copy /y extras\assets\xmls\levels\lvls-n.xml levels\levels.xml >nul
goto zuma
:har
cls
copy /y extras\assets\xmls\levels\lvls-h.xml levels\levels.xml >nul
goto zuma
:lun
cls
copy /y extras\assets\xmls\levels\lvls-l.xml levels\levels.xml >nul
goto zuma
REM --------------------------
REM ---
REM --- Scan if extra assets are installed
REM ---
REM --------------------------
:assetscan
color 0b
cls
echo Ŀ
echo  First, checking if assets folder exists...                                  
echo 
IF EXIST "extras\assets" (
  echo Assets folder detected
  goto findexits
) ELSE (
  goto noassets
)
:findexits
IF EXIST "extras\assets\exits" (
  echo Exits folder detected
  goto findtxt
) ELSE (
  goto noexits
)
REM --- No assets
:noassets
color 0c
echo Assets folder was not found. Press any key to go back to the main menu.
pause >nul
goto menu
REM --- No exits
:noexits
color 0c
echo Exits folder was not found. Press any key to go back to the main menu.
pause >nul
goto menu
:findtxt
IF EXIST "extras\assets\exits\batsettings\CurrentExitSettings.txt" (
  echo Text file detected
  goto DetermineExit
) ELSE (
  goto CreateExitFile
)
:CreateExitFile
echo UNKNOWN > "extras\assets\exits\batsettings\CurrentExitSettings.txt"
goto DetermineExit
:DetermineExit
set _ExitAsset=x
REM --- Wormhole (Default)
find "WORMHOLE" extras\assets\exits\batsettings\CurrentExitSettings.txt
IF %ERRORLEVEL% EQU 0 set _ExitAsset=1 && goto exitselector
REM --- Stargate
find "STARGATE" extras\assets\exits\batsettings\CurrentExitSettings.txt
IF %ERRORLEVEL% EQU 0 set _ExitAsset=2 && goto exitselector
REM --- Unknown
find "UNKNOWN" extras\assets\exits\batsettings\CurrentExitSettings.txt
IF %ERRORLEVEL% EQU 0 set _ExitAsset=x && goto exitselector
:exitselector
REM --------------------------
REM ---
REM --- Exit selector
REM ---
REM --------------------------
cls
color 0e
echo Ŀ
echo  Exit Selector                                                               
echo Ĵ
IF %_ExitAsset% EQU 1 echo  Selected Exit: Wormhole (Default)                                           
IF %_ExitAsset% EQU 2 echo  Selected Exit: Stargate                                                     
IF %_ExitAsset% EQU x echo  Selected Exit: Unknown                                                      
echo Ĵ
echo  1  Wormhole (Default)                                                      
echo  2  Stargate                                                                
echo Ĵ
echo  B  Go back                                                                 
echo 
CHOICE /C 12B /N
IF %ERRORLEVEL% EQU 1 goto wormh
IF %ERRORLEVEL% EQU 2 goto starg
IF %ERRORLEVEL% EQU 3 goto menu
REM --------------------------
REM ---
REM --- Change to several assets
REM ---
REM --------------------------
:wormh
cls
copy /y extras\assets\exits\wormhole\_pitcover.png images\_pitcover.png
copy /y extras\assets\exits\wormhole\pitcover.png images\pitcover.png
echo WORMHOLE > extras\assets\exits\batsettings\CurrentExitSettings.txt
goto zuma
:starg
cls
copy /y extras\assets\exits\stargate\_pitcover.png images\_pitcover.png
copy /y extras\assets\exits\stargate\pitcover.png images\pitcover.png
echo STARGATE > extras\assets\exits\batsettings\CurrentExitSettings.txt
goto zuma
REM --------------------------
REM ---
REM --- Thumbnail Changer
REM ---
REM --------------------------
:thumbnailscan
color 0b
cls
echo Ŀ
echo  First, checking if assets\thumbnails exists...                              
echo 
IF EXIST "extras\assets\thumbnails" (
  echo Thumbnails folder detected
  goto mainthumbnailscan
) ELSE (
  goto nothumbnails
)
:nothumbnails
color 0c
echo Thumbnails folder was not found. Press any key to go back to the main menu.
pause >nul
goto menu
:mainthumbnailscan
color 0b
cls
echo Ŀ
echo  Checking for any thumbnail folders outside game folder...                   
echo 
IF EXIST "%ProgramData%\PopCap Games\Zuma\levels\cached_thumbnails" (
  echo PopCap-DRM thumbnail location detected!
  set _PD-Zuma=y
  goto steamcheck
) ELSE (
  echo PopCap-DRM thumbnail location not found!
  set _PD-Zuma=n
  goto steamcheck
)
:steamcheck
IF EXIST "%ProgramData%\Steam\Zuma\levels\cached_thumbnails" (
  echo Steam-DRM thumbnail location detected!
  set _Steam-Zuma=y
  goto installscreen
) ELSE (
  echo Steam-DRM thumbnail location not found!
  set _Steam-Zuma=n
  goto installscreen
)
color 0e
:installscreenbeep
echo ^G
goto installscreen
:installscreen
cls
echo Ŀ
echo  Install CMZM Thumbnails                                                     
echo Ĵ
IF %_PD-Zuma% EQU y echo  1  popcapgame1.exe (ProgramData\PopCap Games\Zuma\levels\cached_thumbnails)
IF %_Steam-Zuma% EQU y echo  2  Steam (ProgramData\Steam\Zuma\levels\cached_thumbnails)                 
IF %_PD-Zuma% EQU n echo     popcapgame1.exe thumbnail path not found                                
IF %_Steam-Zuma% EQU n echo     Steam thumbnail path not found                                          
echo Ĵ
echo  B  Go back                                                                 
echo Ĵ
echo  If you have the PopCap DRM (popcapgame1) version of Zuma Deluxe, select 1.  
echo  If you installed the mod on a Steam copy, select 2.                         
echo                                                                              
echo  If you installed the mod on a copy that reads thumbnails from the game's    
echo  levels folder, you do not need to use this.                                 
echo 
CHOICE /C 12B /N
IF %ERRORLEVEL% EQU 1 goto popcapgame1tc
IF %ERRORLEVEL% EQU 2 goto steamtc
IF %ERRORLEVEL% EQU 3 goto menu
:popcapgame1tc
IF %_PD-Zuma% EQU y goto popcapgame1t
IF %_PD-Zuma% EQU n goto installscreenbeep
:steamtc
IF %_Steam-Zuma% EQU y goto steamt
IF %_Steam-Zuma% EQU n installscreenbeep
REM --- Installing Thumbnails
:popcapgame1t
cls
color 0a
echo Copying thumbnail files to:
echo %ProgramData%\PopCap Games\Zuma\levels\cached_thumbnails
echo.
copy extras\assets\thumbnails\*.png %ProgramData%\PopCap Games\Zuma\levels\cached_thumbnails /y
goto menu
:steamt
cls
color 0a
echo Copying thumbnail files to:
echo %ProgramData%\Steam\Zuma\levels\cached_thumbnails
echo.
copy extras\assets\thumbnails\*.png %ProgramData%\Steam\Zuma\levels\cached_thumbnails /y
goto menu